// Class-42 - Classical inheritance in 42 lines of JavaScript.
var _ = require("underscore");
var slice = Array.prototype.slice.call;

var allocating = false;
var Class = function() {};

Class.prototype.initialize = function() {};
_.extend(Class, {
  initialize: function(instance) {
    this.prototype.initialize.apply(instance, slice(arguments, 1));
  },

  allocate: function() {
    try {
      allocating = true;
      return new this();
    } finally {
      allocating = false;
    }
  },
  
  extend: function(/* modules */) {
    var ctor = function() {
      if (!allocating) this.initialize.apply(this, arguments);
    };

    var prototype = this.allocate();
    _.each(arguments, function(module) {
      _.extend(prototype, _.isFunction(module) ? module.prototype : module);
    });
    prototype.constructor = ctor;
    
    _.extend(ctor, this);
    ctor.superclass = this;
    ctor.prototype = prototype;
    
    return ctor;
  }
});

module.exports = Class;
